﻿Imports System.Windows.Forms
Imports System.Threading
Imports System.IO
Imports System.Reflection

Module autologin
    Private completed As Boolean = False
    Private wb As WebBrowser
    Private un As String
    Private pw As String

    <STAThread()> _
    Sub Main()
        Console.ForegroundColor = ConsoleColor.Yellow
        Console.WriteLine("DynDNS AutoLogin " + Application.ProductVersion.Substring(0, 3))
        Console.WriteLine("Copyright (C) 2013 Mario Zagaria (http://mariozagaria.it)")
        Console.WriteLine("Released under GNU GPL v3 license (http://www.gnu.org/licenses/gpl.html)")
        Console.WriteLine("")
        Console.ResetColor()
        If CollectParameters() Then
            Execute("https://account.dyn.com/")
        End If
        Console.WriteLine("Done.")
        'Console.ReadKey()
    End Sub

    Private Function CollectParameters() As Boolean
        If My.Application.CommandLineArgs.Count < 2 Then
            ShowHelp()
            Return False
        End If
        un = My.Application.CommandLineArgs(0)
        pw = My.Application.CommandLineArgs(1)
        Return True
    End Function

    Private Function ExeName() As String
        Dim filePath = New Uri(Assembly.GetExecutingAssembly().CodeBase).LocalPath
        Return Path.GetFileName(filePath).ToLower
    End Function

    Private Sub ShowHelp()
        Console.WriteLine("usage: " + ExeName() + " username password")
    End Sub

    Private Sub Execute(ByVal url As String)
        Try
            Console.WriteLine("Accessing " + url + " ...")
            wb = New WebBrowser()
            wb.ScriptErrorsSuppressed = True
            AddHandler wb.DocumentCompleted, New WebBrowserDocumentCompletedEventHandler(AddressOf wb_DocumentCompleted)
            wb.Navigate(url)
            While Not completed
                Application.DoEvents()
                Thread.Sleep(500)
            End While
        Catch ex As Exception
            Console.WriteLine("Errore Non Previsto: " + ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub

    Private Sub wb_DocumentCompleted(ByVal sender As Object, ByVal e As WebBrowserDocumentCompletedEventArgs)
        If isLoggedIn() Then
            Console.WriteLine("Logged In.")
            completed = True
        Else
            Console.WriteLine("Filling Form Details...")
            FillTheForm(un, pw)
        End If
    End Sub

    Private Function isLoggedIn() As Boolean
        Dim pp As HtmlElementCollection = wb.Document.GetElementById("topnav").GetElementsByTagName("span")
        Dim result As Boolean = False
        For Each p As HtmlElement In pp
            If p.InnerText.Contains(un) Then result = True
        Next
        Return result
    End Function

    Private Sub FillTheForm(ByVal _username As String, ByVal _password As String)
        Dim inputs As HtmlElementCollection = wb.Document.GetElementsByTagName("input")

        For Each i As HtmlElement In inputs
            Try
                If i.Id.Contains("username") Then i.InnerText = _username
                If i.Id.Contains("password") Then i.InnerText = _password
            Catch ex As Exception
                ' alcuni input non hanno id, si verificano di sicuro errori irrilevanti
            End Try
        Next

        For Each i As HtmlElement In inputs
            Try
                If i.Id.Contains("submit") Then i.InvokeMember("click")
            Catch ex As Exception
            End Try
        Next
    End Sub

End Module